<?php
/**
 *
 * @category        modules
 * @package         reviews
 * @author          Ruud Eisinga
 * @link			http://www.dev4me.nl/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.6 and higher
 * @version         1.3
 * @lastmodified    februari 3, 2018
 *
 */

if(defined('WB_PATH') == false) { exit("Cannot access this file directly"); }


$database->query("DROP TABLE IF EXISTS `".TABLE_PREFIX."mod_review_cfg`");
$mod_setting = "CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."mod_review_cfg` (
	`section_id` INT(11) NOT NULL DEFAULT '0',
	`review_id` INT(11) NOT NULL DEFAULT '1',
	`active` INT(1) NOT NULL DEFAULT '1',
	PRIMARY KEY (`section_id`)
)
COLLATE='utf8_unicode_ci'
ENGINE=MyISAM;
";
$database->query($mod_setting);


$database->query("DROP TABLE IF EXISTS `".TABLE_PREFIX."mod_review_types`");
$mod_types = "CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."mod_review_types` (
	`review_id` INT(11) NOT NULL AUTO_INCREMENT,
	`name` VARCHAR(255) NOT NULL DEFAULT '',
	`must_approve` INT(11) NOT NULL DEFAULT '1',
	`stopforumspam` INT(11) NOT NULL DEFAULT '0',
	`moderator_email` VARCHAR(255) NOT NULL DEFAULT '',
	`review_what` INT(11) NOT NULL DEFAULT '1',
	`review_type` INT(11) NOT NULL DEFAULT '1',
	`page_id` INT(11) NOT NULL DEFAULT '0',
	`item_id` INT(11) NOT NULL DEFAULT '0',
	`page_title` VARCHAR(255) NOT NULL DEFAULT '',
	`page_url` VARCHAR(512) NOT NULL DEFAULT '',
	`reviews_pageone` INT(11) NOT NULL DEFAULT '3',
	`reviews_per_page` INT(11) NOT NULL DEFAULT '10',
	`name_question` TEXT NOT NULL DEFAULT '',
	`general_question` TEXT NOT NULL DEFAULT '',
	`comment_question` TEXT NOT NULL DEFAULT '',
	`review_q1` TEXT NOT NULL DEFAULT '',
	`review_q2` TEXT NOT NULL DEFAULT '',
	`review_q3` TEXT NOT NULL DEFAULT '',
	`review_q4` TEXT NOT NULL DEFAULT '',
	`review_q5` TEXT NOT NULL DEFAULT '',
	`input_template` VARCHAR(50) NOT NULL DEFAULT '',
	`output_template` VARCHAR(50) NOT NULL DEFAULT '',
	PRIMARY KEY (`review_id`)
)
COLLATE='utf8_unicode_ci'
ENGINE=MyISAM;
";
$database->query($mod_types);


$database->query("DROP TABLE IF EXISTS `".TABLE_PREFIX."mod_review_data`");
$mod_rating = "CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."mod_review_data` (
	`id` INT(11) NOT NULL AUTO_INCREMENT,
	`in_reply_to` INT(11) NOT NULL DEFAULT '0',
	`section_id` INT(11) NOT NULL DEFAULT '0',
	`item_id` INT(11) NOT NULL DEFAULT '0',
	`item_title` VARCHAR(500) NOT NULL DEFAULT '',
	`review_id` INT(11) NOT NULL DEFAULT '0',
	`review_guid` VARCHAR(64) NOT NULL DEFAULT '',
	`ip_address` VARCHAR(40) NOT NULL DEFAULT '',
	`timestamp` INT(11) NOT NULL DEFAULT '0',
	`approved` INT(11) NOT NULL DEFAULT '1',
	`spamflagged` INT(1) NOT NULL DEFAULT '0',
	`like` INT(11) NOT NULL DEFAULT '0',
	`notlike` INT(11) NOT NULL DEFAULT '0',
	`review1` INT(2) NOT NULL DEFAULT '0',
	`review2` INT(2) NOT NULL DEFAULT '0',
	`review3` INT(2) NOT NULL DEFAULT '0',
	`review4` INT(2) NOT NULL DEFAULT '0',
	`review5` INT(2) NOT NULL DEFAULT '0',
	`comment_title` VARCHAR(500) NOT NULL DEFAULT '',
	`comment` TEXT NOT NULL,
	`user_name` VARCHAR(255) NOT NULL DEFAULT '',
	`user_email` VARCHAR(255) NOT NULL DEFAULT '',
	`user_website` VARCHAR(255) NOT NULL DEFAULT '',
	`user_guid` VARCHAR(64) NOT NULL DEFAULT '',
	`user_confirmed` INT(11) NOT NULL DEFAULT '0',
	PRIMARY KEY (`id`),
	INDEX `review_id` (`review_id`),
	INDEX `section_id` (`section_id`, `item_id`),
	INDEX `ip_address` (`ip_address`)
)
COLLATE='utf8_unicode_ci'
ENGINE=MyISAM;
";
$database->query($mod_rating);


$database->query("DROP TABLE IF EXISTS `".TABLE_PREFIX."mod_review_likes`");
$mod_likes = "CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."mod_review_likes` (
	`like_id` INT(11) NOT NULL AUTO_INCREMENT,
	`ipkey` VARCHAR(255) NOT NULL DEFAULT '',
	`ip` VARCHAR(16) NOT NULL DEFAULT '0',
	`agent` VARCHAR(255) NOT NULL DEFAULT '0' ,	
	`timestamp` INT(11) NOT NULL DEFAULT '0',
	`review_id` INT(11) NOT NULL DEFAULT '0',
	`like` INT(1) NOT NULL DEFAULT '0',
	`notlike` INT(1) NOT NULL DEFAULT '0',
	PRIMARY KEY (`like_id`),
	INDEX `ip` (`ipkey`, `timestamp`),
	INDEX `review_id` (`review_id`)
)
COLLATE='utf8_unicode_ci'
ENGINE=MyISAM;
";
$database->query($mod_likes);


?>