<?php
/**
 *
 * @category        modules
 * @package         reviews
 * @author          Ruud Eisinga
 * @link			http://www.dev4me.nl/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.6 and higher
 * @version         1.3
 * @lastmodified    februari 3, 2018
 *
 */

require('../../config.php');
require(WB_PATH.'/modules/admin.php');

require_once (dirname(__FILE__).'/info.php');
require_once (dirname(__FILE__).'/reviews.class.php');

if(!file_exists(dirname(__FILE__).'/languages/'.LANGUAGE.'.php')) {
	require_once(dirname(__FILE__).'/languages/EN.php');
} else {
	require_once(dirname(__FILE__).'/languages/'.LANGUAGE.'.php');
}

$section_id = $_GET['section_id'];
$reviews = new Reviews($section_id);

$current = $reviews->review_id;
$nochange = (int)$reviews->get_total_review_count($current) > 0;
if(!$nochange) {
	if(isset($_GET['delete'])) {
		$rdel = (int)$_GET['delete'];
		$reviews->del_review_type($rdel);
	}
	if(isset($_POST['review_id'])) {
		$current = $reviews->get_post('review_id');
		$reviews->get_review_type($current);
	}
}
?>
<table cellpadding="0" cellspacing="0" border="0" width="100%">
	<tr>
		<td colspan="2"><h2>Reviews <span>by dev4me</span></h2></td>
	</tr>
</table>

<form name="store_cfg" method="post">
	<input type="hidden" name="section_id" value="<?php echo $section_id ?>" />
	<input type="hidden" name="page_id" value="<?php echo $page_id ?>" />
	<h3><?php echo $R['EDITPROFILE'] ?> </h3>
	<?php echo $reviews->get_select_reviewTypes($current,1,1) ?>
</form>
<br/>
<div id="profile" class="profile">
<form name="store_profile" method="post" action="<?php echo WB_URL; ?>/modules/<?php echo $module_directory ?>/save.php" >
	<input type="hidden" name="form_id" value="2" />
	<input type="hidden" name="section_id" value="<?php echo $section_id ?>" />
	<input type="hidden" name="page_id" value="<?php echo $page_id ?>" />
	<input type="hidden" name="review_id" value="<?php echo $current ?>" />
	<table class="rtable">
	<tr>
		<td colspan="2" class="td1">
		<?php echo $R['TOTAL_COMMENTS'] ?>: <?php echo $reviews->get_total_review_count($current) ?>&nbsp;
		<?php echo $R['ON_PAGES_1'] ?> <?php echo $reviews->get_total_review_pages($current) ?> <?php echo $R['ON_PAGES_2'] ?>
		<?php if ($current > 0 && $reviews->get_total_review_pages($current) == 0) { ?>
		<span style="float:right"><a class="rvbutton" onclick='return confirm("<?php echo $R['DELETE_SURE'] ?>");' href="?page_id=<?php echo $page_id ?>&section_id=<?php echo $section_id ?>&delete=<?php echo $current ?>"><?php echo $R['DELETE_PROFILE'] ?></a></span>
		<?php } ?>
		</td>
	</tr>
	<tr><td colspan="2"><hr></td></tr>
	<tr><td class="td1"><?php echo $R['PROFILE_NAME'] ?></td><td class="td2"><input class="t" type="text" name="name" value="<?php echo $reviews->review_type['name'] ?>" required /></td></tr>
	<tr><td class="td1"><?php echo $R['MOD_EMAIL'] ?></td><td class="td2"><input class="t" type="text" name="moderator_email" value="<?php echo $reviews->review_type['moderator_email'] ?>" required /></td></tr>

	<tr><td class="td1"><?php echo $R['INPUT_TEMPLATE'] ?></td><td class="td2">
		<?php echo $reviews->get_selectTemplate("form", "input_template", "review_select_medium", $reviews->review_type['input_template'] ) ?>
		</td></tr>

	<tr><td class="td1"><?php echo $R['OUTPUT_TEMPLATE'] ?></td><td class="td2">
		<?php echo $reviews->get_selectTemplate("reviews", "output_template", "review_select_medium", $reviews->review_type['output_template'] ) ?>
		</td></tr>

	<tr><td class="td1"><?php echo $R['REVIEWS_APPROVAL'] ?></td><td class="td2">
		<?php echo $reviews->get_review_approve_select("must_approve", "review_select_medium", $reviews->review_type['must_approve'] ) ?>
		</td></tr>
		
	<tr><td class="td1"><?php echo $R['STOPFORUMSPAM'] ?></td><td class="td2"><input class="tc" type="checkbox" name="stopforumspam" value="1" <?php echo ( $reviews->review_type['stopforumspam'] ? "checked='checked'":""); ?>  /></td></tr>
		
		
	<tr><td class="td1"><?php echo $R['REVIEW_WHAT'] ?></td><td class="td2">
		<?php echo $reviews->get_review_what_select("review_what", "review_select_medium", $reviews->review_type['review_what'] ) ?>
		</td></tr>
	<tr><td class="td1"><?php echo $R['NUMBER_SHOW_START'] ?></td><td class="td2">
		<?php echo $reviews->get_review_select("reviews_pageone", "review_select_small", 0, 10, 1,$reviews->review_type['reviews_pageone'] ) ?>
		</td></tr>
	<tr><td class="td1"><?php echo $R['NUMBER_SHOW_PAGE'] ?></td><td class="td2">
		<?php echo $reviews->get_review_select("reviews_per_page", "review_select_small", 5, 50, 5,$reviews->review_type['reviews_per_page'] ) ?>
		</td></tr>
	<tr><td colspan="2"><hr></td></tr>

	<tr><td class="td1"><?php echo $R['NAME_QUESTION'] ?></td><td class="td2"><input class="t" type="text" name="name_question" value="<?php echo $reviews->review_type['name_question'] ?>"  /></td></tr>
	<tr><td colspan="2"><hr></td></tr>

	<tr><td class="td1"><?php echo $R['RATING_QUESTION'] ?></td><td class="td2"><input class="t" type="text" name="general_question" value="<?php echo $reviews->review_type['general_question'] ?>"  /></td></tr>
	<tr><td class="td1 ins"><?php echo $R['RATE1'] ?></td><td class="td2"><input class="ts" type="text" name="review_q1" value="<?php echo $reviews->review_type['review_q1'] ?>" /></td></tr>
	<tr><td class="td1 ins"><?php echo $R['RATE2'] ?></td><td class="td2"><input class="ts" type="text" name="review_q2" value="<?php echo $reviews->review_type['review_q2'] ?>" /></td></tr>
	<tr><td class="td1 ins"><?php echo $R['RATE3'] ?></td><td class="td2"><input class="ts" type="text" name="review_q3" value="<?php echo $reviews->review_type['review_q3'] ?>" /></td></tr>
	<tr><td class="td1 ins"><?php echo $R['RATE4'] ?></td><td class="td2"><input class="ts" type="text" name="review_q4" value="<?php echo $reviews->review_type['review_q4'] ?>" /></td></tr>
	<tr><td class="td1 ins"><?php echo $R['RATE5'] ?></td><td class="td2"><input class="ts" type="text" name="review_q5" value="<?php echo $reviews->review_type['review_q5'] ?>" /></td></tr>
	<tr><td colspan="2"><hr></td></tr>

	<tr><td class="td1"><?php echo $R['COMMENT_QUESTION'] ?></td><td class="td2"><input class="t" type="text" name="comment_question" value="<?php echo $reviews->review_type['comment_question'] ?>"  /></td></tr>

	
	
	</table>
	<br/>
	<table class="rtable">
		<tr>
			<td align="left">
				<input class="rvbutton" name="save" type="submit" value="<?php echo $R['SAVE']; ?>" style="margin-top: 5px;">
				<?php if(!$nochange) { ?><input class="rvbutton" name="save_new" type="submit" value="<?php echo $R['SAVEASNEW']; ?>" style="margin-top: 5px;"><?php } ?>
			</td>
			<td align="right">
				<input class="rvbutton" type="button" value="<?php echo $R['CANCEL']; ?>" onclick="javascript: window.location = '<?php echo ADMIN_URL; ?>/pages/modify.php?page_id=<?php echo $page_id; ?>';" style="width: 100px; margin-top: 5px;" />
			</td>
		</tr>
	</table>
</form>
</div>


