<?php
/**
 *
 * @category        modules
 * @package         reviews
 * @author          Ruud Eisinga
 * @link			http://www.dev4me.nl/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.6 and higher
 * @version         1.3
 * @lastmodified    februari 3, 2018
 *
 */

require_once (WB_PATH.'/framework/functions.php');
global $R;  // text messages from languagefile

class Reviews {

	public $section_id = 0;
	public $review_id = 0;
	public $active = 1;
	public $stopforumspam = 0;
	public $page = 0;
	public $reviews_pageone = 3;
	public $review_what = 1;
	public $must_approve = 1;
	public $max_per_page = 10;
	public $total_pages = 0;
	public $active_check = '';
	public $review_type = array();
	public $review_data = array();
	public $templates = array();
	public $action = 'show';	
	public $review_count = 0;
	public $review_average = 0;
	public $max_rating = 5;
	
	
	public function __construct($section_id) {
		$this->clean_up();
		$this->section_id = $section_id;	
		$this->get_settings($section_id);	
		$this->get_review_type();
		if($this->review_what == 2) $this->section_id = 0;
		$this->get_action();
		if($this->action == "reply") $this->save_reply();
		if($this->action == "save") $this->save_review();
		if($this->action == "action") $this->update_data();
		if($this->action == "confirm") $this->update_user();
		$this->get_review_count();
		$this->get_review_av();
	}
	
	private function get_settings($section_id = 0) {
		global $database;
		$query = "SELECT * FROM ".TABLE_PREFIX."mod_review_cfg WHERE section_id = '$section_id'";
		if($get_settings = $database->query($query)) {
			$settings = $get_settings->fetchRow(MYSQL_ASSOC);
			$this->review_id = $settings['review_id'];
			$this->active = $settings['active'];
			if($this->active) $this->active_check = 'checked';
		} 
	}

	private function get_action() {
		if(isset($_GET['show'])) 	$this->action = 'show';
		if(isset($_GET['all'])) 	$this->action = 'show_all';
		if(isset($_GET['new'])) 	$this->action = 'new';
		if(isset($_POST['save'])) 	$this->action = 'save';
		if(isset($_POST['r_id'])) 	$this->action = 'reply';
		if(isset($_GET['page'])) 	$this->page = intval($_GET['page']);
		if(isset($_GET['action'])) 	$this->action = 'action';
		if(isset($_GET['confirm'])) $this->action = 'confirm';
	}

	private function get_review_count($rid = 0) {
		global $database;
		$sid = $this->section_id;
		if(!$rid) $rid = $this->review_id;
		$add_query = $this->isAdministrator() ? "" : " AND `approved` > '0' AND `user_confirmed` > '0' AND `spamflagged` = '0'";
		$item_id = $this->get_item_id();
		if($item_id) $add_query .= " AND `item_id` = '$item_id'";
		$query = "SELECT count(*) FROM `".TABLE_PREFIX ."mod_review_data` where `in_reply_to` = '0' AND `review_id`='$rid' AND `section_id`='$sid' $add_query";
		$this->review_count = $database->get_one($query);
		$this->total_pages = ceil($this->review_count / $this->max_per_page);
		return $this->review_count;
	}
		
	public function get_total_review_count($rid = 0) {
		global $database;
		if(!$rid) $rid = $this->review_id;
		$section_id = $this->section_id;
		$extra = $section_id ? "AND `section_id` = '$section_id'": '';
		$query = "SELECT count(*) FROM `".TABLE_PREFIX ."mod_review_data` where `in_reply_to` = '0' AND `review_id`='$rid' $extra";
		$total = $database->get_one($query);
		return $total;
	}	
	
	public function get_total_review_pages($rid = 0) {
		global $database;
		if(!$rid) $rid = $this->review_id;
		$query = "SELECT count(*) FROM `".TABLE_PREFIX ."mod_review_cfg` where `in_reply_to` = '0' AND `review_id`='$rid'";
		$total = $database->get_one($query);
		return $total;
	}
	
	
	private function get_review_av() {
		global $database;
		$sid = $this->section_id;
		$rid = $this->review_id;
		$add_query = $this->isAdministrator() ? "" : " AND `approved` > '0' AND `user_confirmed` > '0'  AND `spamflagged` = '0'";
		$item_id = $this->get_item_id();
		if($item_id) $add_query .= " AND `item_id` = '$item_id'";
		$av='';
		$avcnt=0;
		for($i=1;$i<=5;$i++) {
			if($this->review_type['review_q'.$i]) {
				if($av) $av .= '+';
				$av .= 'review'.$i;
				$avcnt++;
			}
		}
		if($av) {
			$query = "SELECT avg(($av)/$avcnt) FROM `".TABLE_PREFIX ."mod_review_data` where `in_reply_to` = '0' AND `review_id`='$rid' AND `section_id`='$sid' $add_query";
			$this->review_average = round($database->get_one($query),1);
		}
	}	
	
	public function get_reviews($page = 1) {
		global $database;
		$retval = array();
		$sid = $this->section_id;
		$rid = $this->review_id;
		$limit = '';
		if($this->page == 0) {
			$limit = 'LIMIT 0,'.$this->reviews_pageone;
		} else {
			$start = ($this->page - 1) * $this->max_per_page;
			$limit = 'LIMIT '.$start.','.$this->max_per_page;
		}
		$add_query = $this->isAdministrator() ? "" : " AND `approved` > '0' AND `user_confirmed` > '0' AND `spamflagged` = '0'";
		$item_id = $this->get_item_id();
		$add_query .= " AND `item_id` = '$item_id'";
		$query = "SELECT * FROM `".TABLE_PREFIX ."mod_review_data` where `in_reply_to` = '0' AND `review_id`='$rid' AND `section_id`='$sid' $add_query ORDER BY `id` DESC $limit";
		$resultset = $database->query($query);
		if($resultset && $resultset->numRows()) {
			while($row = $resultset->fetchRow(MYSQL_ASSOC)) {
				$this->htmlspecial_array($row);
				$row = str_replace('[[','&#91;&#91;',$row); //prevent droplets in user-formdata
				$row = str_replace(']]','&#93;&#93;',$row);
				$retval[] = $row;
			}
		}
		return $retval;

	}
	public function get_replies($id) {
		global $database;
		$retval = array();
		$query = "SELECT * FROM `".TABLE_PREFIX ."mod_review_data` where `in_reply_to`='$id' ORDER BY `id` ASC";
		$resultset = $database->query($query);
		if($resultset && $resultset->numRows()) {
			while($row = $resultset->fetchRow(MYSQL_ASSOC)) {
				$this->htmlspecial_array($row);
				$row = str_replace('[[','&#91;&#91;',$row); //prevent droplets in user-formdata
				$row = str_replace(']]','&#93;&#93;',$row);
				$retval[] = $row;
			}
		}
		return $retval;

	}
	
	public function get_item_id() {
		global $post_id;
		if(defined('ITEM_ID')) return ITEM_ID;
		if(defined('POST_ID')) return POST_ID;
		if(defined('TOPIC_ID')) return TOPIC_ID;
		if(isset($post_id) && $post_id) return $post_id;
		return 0;
	}
	private function get_single_review($id) {
		global $database;
		$query = "SELECT * FROM `".TABLE_PREFIX ."mod_review_data` where `id`='$id'";
		$resultset = $database->query($query);
		if($resultset && $resultset->numRows()) {
			$row = $resultset->fetchRow(MYSQL_ASSOC);
			return $row;
		}
	}
	
	private function get_reviewTypes() {
		global $database;
		$retval = array();
		$query = "SELECT * FROM ".TABLE_PREFIX."mod_review_types ";
		$resultset = $database->query($query);
		if($resultset && $resultset->numRows()) {
			while($row = $resultset->fetchRow(MYSQL_ASSOC)) {
				$retval[] = $row;
			}
		}
		return $retval;
	}
	
	public function  get_select_reviewTypes($current = 0, $new = 0, $autosubmit = false) {
		global $R;
		$extra = '<span class="rvinfo">'.$R['CHOOSEWARNING'].'</span>';
		$types = $this->get_reviewTypes();
		if($current == 0) $current = $this->review_id;
		$submit = $autosubmit ? ' onchange="this.form.submit()"':'';
		if($this->get_total_review_count($current) > 0) {
			$submit = 'disabled';
			$extra = '<span class="rvwarning">'.$R['HASREVIEWS'].'</span>';
		}
		$retval = '<select '.$submit.' required class="select_review" name="review_id">';
		$retval .= '  <option  value="">'.$R['CHOOSEPROFILE'].'</option>';
		$newcur = $current == -1 ? ' selected="selected"':'';
		if($new) $retval .= '  <option '.$newcur.' value="-1">'.$R['NEWPROFILE'].'</option>';
		foreach($types as $type) {
			$sel = $type['review_id'] == $current ? 'selected="selected"':'';
			$rc = $this->get_review_count($type['review_id']);
			$rc = $rc ? ' ('.$rc.' '.$R['CURRENT_PAGE'].')':'';
			$retval .= '  <option '.$sel.' value="'.$type['review_id'].'">'.$type['name'].$rc.'</option>';
		}
		$retval .= "</select><br>$extra";
		return $retval;
	}
	
	public function get_review_type($review_id = 0) {
		global $database;
		if($review_id == 0) $review_id = $this->review_id;
		$this->review_type = $this->get_type_fields();
		$query = "SELECT * FROM ".TABLE_PREFIX."mod_review_types WHERE `review_id`='$review_id' LIMIT 1";
		$resultset = $database->query($query);
		if($resultset && $resultset->numRows()) {
			$row = $resultset->fetchRow(MYSQL_ASSOC);
			$this->reviews_pageone = $row['reviews_pageone'];
			$this->max_per_page = $row['reviews_per_page'];
			$this->stopforumspam = $row['stopforumspam'];
			$this->review_what = $row['review_what'];
			$this->must_approve = $row['must_approve'];
			$this->review_type = $row;
		}
	}
	
	public function del_review_type($review_id = 0) {
		global $database;
		if($review_id <= 0) return;
		$query = "DELETE FROM ".TABLE_PREFIX."mod_review_types WHERE `review_id`='$review_id'";
		$database->query($query);
	}
	
	private function get_type_fields() {
		$type_fields = array(
			'review_id' => -1,
			'name' => '',
			'must_approve' => '2',
			'stopforumspam' => '1',
			'moderator_email' => @$_SESSION['EMAIL'],
			'review_what' => '1',
			'review_type' => '0',
			'page_id' => '0',
			'page_title' => '',
			'page_url' => '',
			'item_id' => '',
			'reviews_pageone' => '3',
			'reviews_per_page' => '10',
			'name_question' => '',
			'general_question' => '',
			'comment_question' => '',
			'review_q1' => '',
			'review_q2' => '',
			'review_q3' => '',
			'review_q4' => '',
			'review_q5' => '',
			'input_template' => '',
			'output_template' => ''
			);
		return $type_fields;
	}
	
	public function get_review_select($label, $class = 'review_select', $start = 1, $max = 5, $step = 1, $current = -1) {
		if(isset($_SESSION['thereview'])) {
			$current = @$_SESSION['thereview'][$label];
		}
		$rval = '<select required id="'.$label.'" name="'.$label.'" class="'.$class.'">';
		$rval .= '  <option value="">-</option>';
		for($x=$start;$x<=$max;$x=$x+$step) {
			$sel = ($x == $current) ? 'selected="selected"':'';
			$rval .= '<option '.$sel.' value="'.$x.'">'.$x.'</option>';
		}
		$rval .= '</select>';
		return $rval;
	}	
	public function get_review_radio($label, $class = 'review_select', $start = 1, $max = 5, $step = 1, $current = -1) {
		if(isset($_SESSION['thereview'])) {
			$current = @$_SESSION['thereview'][$label];
		}
		$rval = '';
		for($x=$start;$x<=$max;$x=$x+$step) {
			$sel = ($x == $current) ? 'checked="checked"':'';
			$rval .= '<input '.$sel.' class="'.$class.'" required type="radio" id="'.$label.$x.'" name="'.$label.'" value="'.$x.'" /><label class="'.$class.'" for="'.$label.$x.'">'.$x.'</label>';
		}
		return $rval;
	}

	public function get_review_what_select($label, $class = 'review_select', $current = -1) {
		global $R;
		$rval = '<select required id="'.$label.'" name="'.$label.'" class="'.$class.'">';
		$rval .= '  <option value="">-</option>';
		foreach($R['WHAT'] as $key => $value) {
			$sel = $key == $current ? 'selected="selected"':'';
			$rval .= '<option '.$sel.' value="'.$key.'">'.$value.'</option>';
		}
		$rval .= '</select>';
		return $rval;
	}
	
	public function get_review_approve_select($label, $class = 'review_select', $current = -1) {
		global $R;
		$rval = '<select required id="'.$label.'" name="'.$label.'" class="'.$class.'">';
		$rval .= '  <option value="">-</option>';
		foreach($R['APPROVE'] as $key => $value) {
			$sel = $key == $current ? 'selected="selected"':'';
			$rval .= '<option '.$sel.' value="'.$key.'">'.$value.'</option>';
		}
		$rval .= '</select>';
		return $rval;
	}

	public function save_review() {
		global $database, $R;
		// error handling.. (IP check etc...)
		if($sec = $this->fastposting(10)) {
			$_SESSION['message'] = '<div class="success">'.$R['TOOFAST'].'</div>';
			$this->reload_page();
			return;
		}
		
		$item_id = $this->get_item_id();
		$set['item_title'] = $this->get_page_title();
		$set['item_id'] = $item_id;
		$set['section_id'] = $this->section_id;
		$set['review_id'] = $this->review_id;
		$set['review_guid'] = $this->GUID();
		$set['timestamp'] = time();
		$set['ip_address'] = $this->get_userIP();
		$set['user_name'] = $this->get_post('user_name');
		$set['user_email'] = $this->get_post('user_email');
		$set['user_website'] = $this->get_post('user_website');
		$set['user_guid'] = $this->GUID();
		$set['review1'] = (int)$this->get_post('review1');
		$set['review2'] = (int)$this->get_post('review2');
		$set['review3'] = (int)$this->get_post('review3');
		$set['review4'] = (int)$this->get_post('review4');
		$set['review5'] = (int)$this->get_post('review5');
		//$set['like'] = (int)$this->get_post('like');
		//$set['notlike'] = (int)$this->get_post('notlike');
		$set['comment_title'] = $this->get_post('comment_title');
		$set['comment'] = $this->get_post('comment');
		$set['spamflagged'] = '0';
		$set['approved'] = '0';
		if($this->must_approve == 1) {
			$set['approved'] = '0';
			$set['user_confirmed'] = '1';
			// send mail to moderator
		} elseif( $this->must_approve == 2 ) { // user and moderator
			$set['approved'] = '0';
			$set['user_confirmed'] = '0';
		} elseif( $this->must_approve == 3 ) {
			$set['approved'] = '1';
			$set['user_confirmed'] = '0';
			//send mail to reviewer
		} elseif($this->must_approve == 4) {
			$set['user_confirmed'] = '1';
			$set['approved'] = '1';
		}
		if($this->stopforumspam) {
			if($this->check_stopForumSpam($set['user_email'],$set['ip_address']) == false) {
				$set['spamflagged'] = '1';
				$set['approved'] = '0';
			}
		}
		$_SESSION['thereview'] = $set;
		$_SESSION['message'] = '';
		if(strlen(trim($set['user_name'])) < 5) {
			$_SESSION['message'] .= '<div class="error">'.$R['INVALID_NAME'].'</div>';
			$this->reload_page();
			return;
		}
		if (!filter_var($set['user_email'], FILTER_VALIDATE_EMAIL)) {
			$_SESSION['message'] .= '<div class="error">'.$R['INVALID_EMAIL'].'</div>';
			$this->reload_page();
			return;
		}
		$id = $this->save_data($set);
		$this->mail_data ($id);
		unset($_SESSION['thereview']);
		$this->action = "show";
		$this->reload_page();
	}
	
	public function save_reply() {
		global $database, $R;
		// error handling.. (IP check etc...)
		$id = hexdec($this->get_post('r_id'))/1234;
		$set['in_reply_to'] = $id;
		$item_id = $this->get_item_id();
		$set['item_title'] = '';
		$set['item_id'] = $item_id;
		$set['section_id'] = $this->section_id;
		$set['review_id'] = $this->review_id;
		$set['review_guid'] = $this->GUID();
		$set['timestamp'] = time();
		$set['ip_address'] = $this->get_userIP();
		$set['user_name'] = $this->get_post('user_name');
		$set['user_email'] = '';
		$set['user_website'] = '';
		$set['user_guid'] = $this->GUID();
		$set['review1'] = 0;
		$set['review2'] = 0;
		$set['review3'] = 0;
		$set['review4'] = 0;
		$set['review5'] = 0;
		//$set['like'] = (int)$this->get_post('like');
		//$set['notlike'] = (int)$this->get_post('notlike');
		$set['comment_title'] = '';
		$set['comment'] = $this->get_post('reply');
		$set['spamflagged'] = '0';
		$set['approved'] = '0';
		$set['user_confirmed'] = '0';
		$set['approved'] = '1';
		$_SESSION['message'] = '';
		$id = $this->save_data($set);
		$this->action = "show";
		$this->reload_page();
	}
	private function update_user($action = null) {
		global $database, $R;
		
		$guid = $this->get_get('confirm');
		if(!$guid) return;
		$query = "SELECT * FROM ".TABLE_PREFIX ."mod_review_data WHERE `user_guid` = '$guid'";
		$resultset = $database->query($query);
		if($resultset && $resultset->numRows()) {
			$row = $resultset->fetchRow(MYSQL_ASSOC);
			if($row['user_confirmed'] == '0') { // not yet confirmed
				$id = $row['id'];
				$time = time();
				$query = "UPDATE ".TABLE_PREFIX ."mod_review_data SET `user_confirmed`='$time' WHERE `id` = '$id'";
				$database->query($query);
				$this->mail_data ($id);
				$_SESSION['message'] = '<div class="success">'.$R['USER_THANKYOU'].'</div>';
			}
		}
		$this->reload_page();
	}
	
	private function clean_up() {
		global $database, $R;
		$query = "SELECT * FROM ".TABLE_PREFIX ."mod_review_data WHERE `user_confirmed` = '0'";
		$resultset = $database->query($query);
		if($resultset && $resultset->numRows()) {
			while($row = $resultset->fetchRow(MYSQL_ASSOC)) {
				$t = $row['timestamp'];
				if($t < time() - (60 * 60 * 48)) {  // 48 hours and still not confirmed? delete!
					$id = $row['id'];
					$database->query("DELETE FROM ".TABLE_PREFIX ."mod_review_data WHERE `id` = '$id'");
				}
			}
		}
	}
	
	private function update_data() {
		global $database;
		
		$guid = $this->get_get('id');
		if(!$guid) return;
		$action = $this->get_get('action');
		if(!$action) return;
		
		if($action == "nospam") {
			$query = "UPDATE ".TABLE_PREFIX ."mod_review_data SET `spamflagged`='0' WHERE `review_guid` = '$guid'";
		} elseif($action == "accept") {
			$query = "UPDATE ".TABLE_PREFIX ."mod_review_data SET `approved`='1' WHERE `review_guid` = '$guid'";
		} elseif($action == "unaccept") {
			$query = "UPDATE ".TABLE_PREFIX ."mod_review_data SET `approved`='0' WHERE `review_guid` = '$guid'";
		} elseif($action == "confirm") {
			$time = time();
			$query = "UPDATE ".TABLE_PREFIX ."mod_review_data SET `user_confirmed`='$time' WHERE `user_guid` = '$guid'";
		} elseif($action == "delete") {
			$query = "DELETE FROM ".TABLE_PREFIX ."mod_review_data WHERE `review_guid` = '$guid'";
		}
		
		if(!isset($query)) return;
		$database->query($query);
		
		$this->reload_page();
		
	}
	
	private function save_data($data) {
		global $database;
		$set = '';
		$val = '';
		if (!isset($data['id']) || $data['id'] <= 0) {
			foreach ( $data as $key => $value ) {
				if ($key != 'id') { // && !$value == '') {
					$set .= $set ? ',`'.$key.'`':'`'.$key.'`';
					$val .= $val ? ",'$value'" : "'$value'";
				}
			}
			$query = "INSERT INTO ".TABLE_PREFIX ."mod_review_data ($set) VALUES ($val)";
			$database->query($query);
			$id = $database->get_one("SELECT LAST_INSERT_ID()");
			return $id;
		} else {
			$id = $data['id'];
			foreach ( $data as $key => $value ) {
				if ($key != 'id') {
					$set .= $set ? ',':'';
					$set .= "`$key`='$value'";
				}
			}
			$query = "UPDATE ".TABLE_PREFIX ."mod_review_data SET $set where `id` = '$id'";
			$database->query($query);
			return $id;
		}
	}
	
	public function fastposting($minutes = 5) {
		global $database;
		$ip = $this->get_userIP();
		$query = "SELECT `timestamp` from ".TABLE_PREFIX ."mod_review_data WHERE `ip_address`='$ip' ORDER BY `timestamp` DESC limit 0,1";
		$last = $database->get_one($query);
		if(time() - $last < 60 * $minutes) return time() - $last; //return true;
		return false;		
	}
	
	public function get_post($postfield) {
		global $database;
		$rval = '';
		if(isset($_POST[$postfield])) {
			if(is_object($database->DbHandle)) {
				$rval = $database->escapeString($_POST[$postfield]);
			} else {
				$rval = mysql_real_escape_string($_POST[$postfield]);
			}
		}
		return $rval;
	}	
	
	public function get_get($getfield) {
		global $database;
		$rval = '';
		if(isset($_GET[$getfield])) {
			if(is_object($database->DbHandle)) {
				$rval = $database->escapeString($_GET[$getfield]);
			} else {
				$rval = mysql_real_escape_string($_GET[$getfield]);
			}
		}
		return $rval;
	}
	
	private function get_userIP() {
		$client  = @$_SERVER['HTTP_CLIENT_IP'];
		$forward = @$_SERVER['HTTP_X_FORWARDED_FOR'];
		$remote  = $_SERVER['REMOTE_ADDR'];
		if(filter_var($client, FILTER_VALIDATE_IP)) {
			$ip = $client;
		} elseif(filter_var($forward, FILTER_VALIDATE_IP)) {
			$ip = $forward;
		} else {
			$ip = $remote;
		}
		return $ip;
	}
	
	private function GUID() {
		return strtolower(sprintf('%04X%04X%04X%04X%04X%04X%04X%04X', mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(16384, 20479), mt_rand(32768, 49151), mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535)));
	}

	public function link_fromUrl($url, $content) {
		$url = strtolower($url);
		if(substr($url,0,7) != "http://" && substr($url,0,8) != "https://") $url = "http://$url";
		$url = filter_var($url, FILTER_SANITIZE_URL);
		if(!filter_var($url, FILTER_VALIDATE_URL) === false) {
			$url = '<a href="'.$url.'" target="_blank" rel="nofollow">'.$content.'</a>';
			return $url;
		}
		return $content;
	}
	
	function page($pid = 0) {
		global $database, $wb;
		$link = $database->get_one("SELECT link FROM ".TABLE_PREFIX."pages WHERE `page_id` = '".$pid."'");
		return $wb->page_link($link);
	}


	
	public function get_selectTemplate($type = "reviews", $label, $class = 'review_select', $current = null) {
		$listarray = $this->get_templates($type);
		$rval = '<select required id="'.$label.'" name="'.$label.'" class="'.$class.'">';
		$rval .= '  <option value="">-</option>';
		foreach ($listarray as $key => $value) {
			$sel = $value == $current ? 'selected="selected"':'';
			$rval .= '<option '.$sel.' value="'.$value.'">'.$key.'</option>';
		}
		$rval .= '</select>';
		return $rval;
	}
	
	
	private function get_templates($type = '') {
		$pattern = dirname(__FILE__).DIRECTORY_SEPARATOR.'templates'.DIRECTORY_SEPARATOR.$type.'_*.htt';
		$listarray = array();
        foreach(glob($pattern) as $filename) {
			$name = substr( basename($filename,".htt") , strlen($type)+1);
			if($type == 'reviews') { // reviews must have containers with the same name
				if (!file_exists(dirname(__FILE__).DIRECTORY_SEPARATOR.'templates'.DIRECTORY_SEPARATOR.'container_'.$name.'.htt')) {
					continue;
				}
			}
			$title = ucwords (str_replace(array("_","-")," ", $name));
			$listarray[$title] =  $name;  //i.e. review_default
		}
        return $listarray;
    }

	public function get_template($type,$name) {
		if(!file_exists(dirname(__FILE__).'/templates/'.$type.'_'.$name.'.htt')) {
			$name = 'default';
			if(!file_exists(dirname(__FILE__).'/templates/'.$type.'_'.$name.'.htt')) return '';
		}
		$tmp = file_get_contents(dirname(__FILE__).'/templates/'.$type.'_'.$name.'.htt');
		//$var[] = "{URL}";				$value[] = $this->page(PAGE_ID);
		$var[] = "{WB_URL}";			$value[] = WB_URL;
		$var[] = "{WEBSITE_TITLE}";		$value[] = WEBSITE_TITLE;
		$var[] = "{MEDIA_DIRECTORY}";	$value[] = MEDIA_DIRECTORY;
		$var[] = "{SERVER_EMAIL}";		$value[] = SERVER_EMAIL;
		$tmp = str_replace($var,$value,$tmp);
		return $tmp;
	}
	
	public function add_template(&$template, $var, $value) {
		$template = str_ireplace($var,$value,$template);
		return $template;
	}	
	public function clean_template(&$template) {
		$template = preg_replace('#\{[A-Za-z_][A-Za-z_0-9.,-\/\\ ]*?\}#s', '', $template); 
		return $template;
	}
	private function htmlspecial_array(&$variable) {
		foreach ($variable as &$value) {
			if (!is_array($value)) { $value = htmlspecialchars($value); }
			else { htmlspecial_array($value); }
		}
	}
	
	private function check_stopForumSpam($email,$ip) {
		$url = "http://api.stopforumspam.org/api?email=$email&ip=$ip&f=json";
		$json = file_get_contents($url);
		$result = json_decode( $json, true );
        if ( $this->appears( 'email', $result ) || $this->appears( 'ip', $result ) ) {
            return false;
        }
		return true;
	}
	private function appears( $val, $result ) {
		if ( isset( $result[$val] ) && is_array( $result[$val] ) && isset( $result[$val]['appears'] ) )
			return $result[$val]['appears'];
		return false;
	}
	
	public function droplet($item_id = 0) {
		global $R;
		$count = $this->get_droplet_count($item_id);
		$av = $this->get_droplet_av($item_id);
		$rval = '';
		if($count) {
			$rval = $count ==  1 ? $count.' '.$R['REVIEW_FOUND'] : $count.' '.$R['REVIEWS_FOUND'];
			$rval .= $this->fa_stars($av);
		}
		return $rval;
	}
	
	
	private function get_droplet_count($item_id = 0) {
		global $database;
		$sid = $this->section_id;
		$query = "SELECT count(*) FROM `".TABLE_PREFIX ."mod_review_data` where 
			`section_id`='$sid' AND 
			`item_id`='$item_id' AND 
			`approved` > '0' AND 
			`user_confirmed` > '0' AND 
			`spamflagged` = '0'";
		$count = $database->get_one($query);
		return $count;
	}

	private function get_droplet_av($item_id = 0) {
		global $database;
		$sid = $this->section_id;
		$rid = $database->get_one("SELECT `review_id` FROM `".TABLE_PREFIX ."mod_review_cfg` WHERE `section_id`='$sid'");
		$av='';
		$avcnt=0;
		for($i=1;$i<=5;$i++) {
			if($this->review_type['review_q'.$i]) {
				if($av) $av .= '+';
				$av .= 'review'.$i;
				$avcnt++;
			}
		}
		if($av) {
			$query = "SELECT avg(($av)/$avcnt) FROM `".TABLE_PREFIX ."mod_review_data` where 
			`review_id`='$rid' AND 
			`section_id`='$sid' AND
			`item_id` = '$item_id' AND 
			`approved` > '0' AND 
			`user_confirmed` > '0' AND
			`spamflagged` = '0'";
			$av = round($database->get_one($query),1);
		}
		return $av;
	}	
	
	private function get_page_title() {
		global $database, $post_id;
		$page = null;
		if(isset($post_id)) {
			$page = $database->query("SELECT *, link as menu_title, content_short as description FROM " . TABLE_PREFIX . "mod_news_posts WHERE `post_id`='".$post_id."'");
		} elseif(defined('TOPIC_ID') && file_exists(WB_PATH.'/modules/topics/module_settings.php')) {
			require(WB_PATH.'/modules/topics/module_settings.php');
			$page = $database->query("SELECT `title` FROM " . TABLE_PREFIX . "mod_topics WHERE `topic_id`='".TOPIC_ID."'");
		} elseif(defined('ITEM_ID')) {
			if($db = $this->getDbForItemId()) {
				$page = $database->query("SELECT `title` FROM " . TABLE_PREFIX."mod_".$db."_items WHERE `item_id`='".ITEM_ID."'");
			} else {
				$page = $database->query("SELECT page_title as title FROM ".TABLE_PREFIX."pages WHERE `page_id` = '".PAGE_ID."'");
			}
		} 
		if(!$page || $page->numRows()==0) {
			$page = $database->query("SELECT page_title as title FROM ".TABLE_PREFIX."pages WHERE `page_id` = '".PAGE_ID."'");
		}
		$settings = $page->fetchRow();
		return $settings['title'];
	}	
	
	
	private function getDbForItemId () {
		global $database;
		if(!defined('ITEM_ID')) return '';
		$item_id = ITEM_ID;
		$page_id = PAGE_ID;
		$modules = $database->query("SELECT `module` FROM ".TABLE_PREFIX."sections WHERE `page_id`='$page_id'");
		if($modules && $modules->numRows()) {
			while ($module = $modules->fetchRow()) {
				$m = $module['module'];
				$res = $database->query("SHOW TABLES LIKE '" . TABLE_PREFIX . "mod_".$m."_items'");
				if($res && $res->numRows()) {
					return $m;
				}
			}
		}
	}
	
	
	
    public function mail_data ($id) { 	
		global $R;

		$set = $this->get_single_review($id);
		$page_link = "http://".$_SERVER['HTTP_HOST'].parse_url($_SERVER["REQUEST_URI"], PHP_URL_PATH);

		if($set['user_confirmed'] == '0' && $set['spamflagged'] == '0') {
		
			$mail = $this->get_template("email","reviewer");
			$mail = $this->add_template($mail,'{USER_HEADER}'	   , $R['USER_HEADER']);
			$mail = $this->add_template($mail,'{USER_TXT_CONFIRM}' , $this->frm_output($R['USER_TXT_CONFIRM']));
			$mail = $this->add_template($mail,'{ACCEPT}'			, '<a href="'.$page_link.'?confirm='.$set['user_guid'].'">'.$page_link.'?confirm='.$set['user_guid'].'</a>');
			$mail = preg_replace('#\{[A-Za-z_][A-Za-z_0-9]*?\}#s', '', $mail); 
			$email = $set['user_email'];
			$this->sendmail($email, SERVER_EMAIL, $R['USER_SUBJECT'], $mail);
			$_SESSION['message'] = '<div class="success">'.$R['USER_MAILSENT'].'</div>';

		}elseif($set['approved'] == '0') {
		
			$mail = $this->get_template("email","moderator");
			$mail = $this->add_template($mail,'{HEADER}'		, $R['EMAIL_HEADER']);
			$mail = $this->add_template($mail,'{TXT_NAME}'		, $R['TXT_NAME']);
			$mail = $this->add_template($mail,'{TXT_EMAIL}'		, $R['TXT_EMAIL']);
			$mail = $this->add_template($mail,'{TXT_WEBSITE}'	, $R['TXT_WEBSITE']);
			$mail = $this->add_template($mail,'{TXT_COMMENT_TITLE}'	, $R['TXT_COMMENT_TITLE']);
			$mail = $this->add_template($mail,'{TXT_COMMENT}'	, $R['TXT_COMMENT']);
			$mail = $this->add_template($mail,'{TXT_PAGE_TITLE}', $R['TXT_PAGE_TITLE']);
			$mail = $this->add_template($mail,'{TXT_PAGE_LINK}'	, $R['TXT_PAGE_LINK']);
			
			$mail = $this->add_template($mail,'{TXT_ACCEPT}'	, $R['TXT_ACCEPT']);
			$mail = $this->add_template($mail,'{TXT_DELETE}'	, $R['TXT_DELETE']);
			$mail = $this->add_template($mail,'{TXT_VIEW}'		, $R['TXT_VIEW']);
			if($set['spamflagged']) {
				$mail = $this->add_template($mail,'{MESSAGE}'	, $R['SPAM_MESSAGE']);
			}
			$mail = $this->add_template($mail,'{NAME}'		, $this->frm_output($set['user_name']));
			$mail = $this->add_template($mail,'{EMAIL}'		, $this->frm_output($set['user_email']));
			$mail = $this->add_template($mail,'{WEBSITE}'	, $this->frm_output($set['user_website']));
			
			for($i=1;$i<=5;$i++) {
				if($this->review_type['review_q'.$i]) {		
					$mail = $this->add_template($mail,'{TXT_REVIEW'.$i.'}',$this->frm_output($this->review_type['review_q'.$i]));
					$mail = $this->add_template($mail,'{REVIEW'.$i.'}',$set['review'.$i]);
				} else {
					$mail = $this->add_template($mail,'{DISPLAY'.$i.'}',' style="display:none"');
				}
			}
			
			$mail = $this->add_template($mail,'{COMMENT_TITLE}'	, $this->frm_output($set['comment_title']));
			$mail = $this->add_template($mail,'{COMMENT}'	, $this->frm_output($set['comment']));
			$mail = $this->add_template($mail,'{ACCEPT}'	, '<a href="'.$page_link.'?action=accept&id='.$set['review_guid'].'">Click</a>');
			$mail = $this->add_template($mail,'{DELETE}'	, '<a href="'.$page_link.'?action=delete&id='.$set['review_guid'].'">Click</a>');
			$mail = $this->add_template($mail,'{VIEW}'		, '<a href="'.$page_link.'">Click</a>');
			$mail = $this->add_template($mail,'{PAGE_LINK}'	, '<a href="'.$page_link.'">'.$page_link.'</a>');
			$mail = $this->add_template($mail,'{PAGE_TITLE}'	, $this->frm_output($set['item_title']));
			//die($mail);
			$mail = preg_replace('#\{[A-Za-z_][A-Za-z_0-9]*?\}#s', '', $mail); 
			$moderator = $this->review_type['moderator_email'];
			$this->sendmail($moderator, $moderator, $R['EMAIL_SUBJECT'], $mail);
			
		}
		return;
		
	}
	
	private function frm_output($string) {
		$string = htmlspecialchars($string);
		$string = nl2br($string);
		return $string;
	}
	
	public function fa_stars($val) {
		$nval= round($val);
		$max = $this->max_rating;
		$fa_star = '<i class="star fa fa-star" aria-hidden="true"></i>';
		$fa_star_o = '<i class="star fa fa-star-o" aria-hidden="true"></i>';
		$res = str_repeat($fa_star,$nval);
		$res .= str_repeat($fa_star_o,$max-$nval);
		$res = '<span class="stars" data-tooltip="'.$val.' / '.$this->max_rating.'">'.$res.'</span>';
		return $res;
	}
	
	private function sendmail($toaddress, $fromaddress, $subject, $message, $fromname='') {
		require_once(WB_PATH."/framework/class.wbmailer.php");

		$fromaddress = preg_replace('/[\r\n]/', '', $fromaddress);
		$toaddress = preg_replace('/[\r\n]/', '', $toaddress);
		$subject = preg_replace('/[\r\n]/', '', $subject);

		$myMail = new wbmailer();
		// set user defined from address
		if ($fromaddress!='') {
			if($fromname!='') $myMail->FromName = $fromname;  // FROM-NAME
			$myMail->From = $fromaddress;                     // FROM:
			$myMail->AddReplyTo($fromaddress);                // REPLY TO:
		}
		// define recepient and information to send out
		$myMail->AddAddress($toaddress);                      // TO:
		$myMail->Subject = $subject;                          // SUBJECT
		$myMail->Body = $message; 		                      // CONTENT (HTML)
		$myMail->AltBody = strip_tags($message);              // CONTENT (TEXT)
		// check if there are any send mail errors, otherwise say successful
		if (!$myMail->Send()) {
			return false;
		} else {
			return true;
		}
	}
		
	private function reload_page() {
		$page_link = "//".$_SERVER['HTTP_HOST'].parse_url($_SERVER["REQUEST_URI"], PHP_URL_PATH);
		if(headers_sent()) {
			echo '<script type="text/javascript">window.location = "'.$page_link.'"</script>';
		} else {
			die(header('Location: '.$page_link , TRUE , 301));
		}
	}
	
	public function is_ajax() {
		return isset($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest';
	}
	
	public function like($review_id) {
		global $database;
		$now = time();
		$ip = $this->get_userIP();
		$agent = $_SERVER['HTTP_USER_AGENT'];
		$ipkey = sha1($this->get_userIP().'|'.$_SERVER['HTTP_USER_AGENT']);
		if($this->canlike($review_id,$ipkey)) {
			$query = "INSERT INTO ".TABLE_PREFIX."mod_review_likes SET
				`ipkey` = '$ipkey',
				`ip` = '$ip',
				`agent` = '$agent',
				`review_id` = '$review_id',
				`timestamp` = '$now',
				`like` = '1',
				`notlike` = '0'
			";
			$database->query($query);
		} else { 
			return false;
		} 
		$thelikes = $this->likes($review_id);
		$query = "UPDATE ".TABLE_PREFIX ."mod_review_data SET `like`='$thelikes' WHERE `id` = '$review_id'";
		$database->query($query);
		return $thelikes;
	}

	public function nolike($review_id) {
		global $database;
		$now = time();
		$ip = $this->get_userIP();
		$agent = $_SERVER['HTTP_USER_AGENT'];
		$ipkey = sha1($this->get_userIP().'|'.$_SERVER['HTTP_USER_AGENT']);
		if($this->canlike($review_id,$ipkey)) {
			$query = "INSERT INTO ".TABLE_PREFIX."mod_review_likes SET
				`ipkey` = '$ipkey',
				`ip` = '$ip',
				`agent` = '$agent',
				`review_id` = '$review_id',
				`timestamp` = '$now',
				`like` = '0',
				`notlike` = '1'
			";
			$database->query($query);
		} else { 
			return false;
		}
		$thelikes = $this->nolikes($review_id);
		$query = "UPDATE ".TABLE_PREFIX ."mod_review_data SET `notlike`='$thelikes' WHERE `id` = '$review_id'";
		$database->query($query);
		return $thelikes;
		
	}

	public function canlike($review_id, $ipkey) {
		global $database;
		//one vote per review
		$query = "SELECT `timestamp` from ".TABLE_PREFIX."mod_review_likes WHERE `ipkey`='$ipkey' AND `review_id`='$review_id'";
		if($database->get_one($query)) return false;
		//one vote per 15 seconds
		/*
		$query = "SELECT `timestamp` from ".TABLE_PREFIX."mod_review_likes WHERE `ipkey`='$ipkey' ORDER BY `timestamp` DESC";
		if($t = $database->get_one($query)) {
			if($t > time() - 15) return false;
		}
		*/
		return true;
	}
	
	public function likes($review_id) {
		global $database;
		$query = "SELECT sum(`like`) from ".TABLE_PREFIX."mod_review_likes WHERE `review_id`='$review_id' AND `like`='1'";
		if($t = $database->get_one($query)) return $t;
		return '0';
	}
	
	public function nolikes($review_id) {
		global $database;
		$query = "SELECT sum(`notlike`) from ".TABLE_PREFIX."mod_review_likes WHERE `review_id`='$review_id' AND `notlike`='1'";
		if($t = $database->get_one($query)) return $t;
		return '0';
	}
	
	public function isAdministrator() {
		global $wb, $admin;
		if($admin->ami_group_member(1)) {  // administrators
			return true;
		}
		return false;
	}
	public function google_snippet() {
		global $R;
		$google = '';
		if($this->review_count) {
			$google = $this->get_template('google','snippet');
			$this->add_template($google,'{VAL_AVG}', $this->review_average);
			$this->add_template($google,'{MAX_VAL}', $this->max_rating);
			$this->add_template($google,'{REVIEW_COUNT}', $this->review_count);
			$this->add_template($google,'{PAGE_TITLE}' , $this->get_page_title());
			$this->add_template($google,'{GOOGLE_PREFIX}' , $R['GOOGLE_PREFIX']);
			$this->add_template($google,'{GOOGLE_AVERAGE}', $R['GOOGLE_AVERAGE']);
			$this->add_template($google,'{GOOGLE_BASED}'  , $R['GOOGLE_BASED']);
			$this->add_template($google,'{GOOGLE_REVIEWS}', $R['GOOGLE_REVIEWS']);
		}
		return $google;
	}
}
