<?php
/**
 *
 * @category        modules
 * @package         reviews
 * @author          Ruud Eisinga
 * @link			http://www.dev4me.nl/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.6 and higher
 * @version         1.3
 * @lastmodified    februari 3, 2018
 *
 */
 
if(defined('WB_PATH') == false) { exit("Cannot access this file directly"); }

require_once (dirname(__FILE__).'/reviews.class.php');
require(dirname(__FILE__).'/languages/EN.php');
if(file_exists(dirname(__FILE__).'/languages/'.$section_id.'.php')) {
	require(dirname(__FILE__).'/languages/'.$section_id.'.php');
}elseif(file_exists(dirname(__FILE__).'/languages/'.LANGUAGE.'.php')) {
	require(dirname(__FILE__).'/languages/'.LANGUAGE.'.php');
}

$page = 0;
$reviews = new Reviews($section_id);

if($reviews->is_ajax()) {
	if(isset($_GET['like']) || isset($_GET['nolike'])) {
		while (ob_get_level() > 0) { ob_end_clean(); }
		$id = hexdec($_GET['id'])/1234;
		if(isset($_GET['like'])) {
			//like
			$data = $reviews->like($id);
		} else {
			//nolike
			$data = $reviews->nolike($id);
		}
		if($data !== false) {
			$return["data"] = $data;
		} else {
			$return["error"] = $R['LIKE_NOACCEPT'];
		}
		die(json_encode($return));
	}
}

if($reviews->review_what > 2 && $reviews->get_item_id() == 0) return;

if($reviews->action == 'new') {

	$template = $reviews->review_type['input_template'];
	$container = $reviews->get_template('form',$template);
	if(isset($_SESSION['message'])) {
		$reviews->add_template($container,'{MESSAGE}', $_SESSION['message']);
		unset($_SESSION['message']);
	}
	if(!$reviews->review_type['name_question']) {
		$reviews->add_template($container,'{HIDE_NAME_Q}',' style="display:none" ');
	} else {
		$reviews->add_template($container,'{NAME_QUESTION}',$reviews->review_type['name_question']);
	}
	$reviews->add_template($container,'{NAME}',$R['NAME']);
	$reviews->add_template($container,'{EMAIL}',$R['EMAIL']);
	$reviews->add_template($container,'{WEBSITE}',$R['WEBSITE']);
	$rating_cnt = 0;
	for($i=1;$i<=5;$i++) {
		if(!$reviews->review_type['review_q'.$i]) {
			$reviews->add_template($container,'{HIDE'.$i.'}',' style="display:none" ');
		} else {
			$rating_cnt++;
			$reviews->add_template($container,'{RATING_Q'.$i.'}',$reviews->review_type['review_q'.$i.'']);
			$reviews->add_template($container,'{RATING_SELECT'.$i.'}',$reviews->get_review_select('review'.$i.'',"review_select",1,$reviews->max_rating));
			$reviews->add_template($container,'{RATING_RADIO'.$i.'}',$reviews->get_review_radio('review'.$i.'',"review_radio",1,$reviews->max_rating));
		}
	}
	if($rating_cnt > 0) {
		if($reviews->review_type['general_question']) {
			$reviews->add_template($container,'{RATING_QUESTION}',$reviews->review_type['general_question']);
		} else {
			$reviews->add_template($container,'{HIDE_Q}',' style="display:none" ');
		}
	} else {
		$reviews->add_template($container,'{HIDE_RATING}',' style="display:none" ');
	}

	if($reviews->review_type['comment_question']) {
		$reviews->add_template($container,'{COMMENT_QUESTION}',$reviews->review_type['comment_question']);
		$reviews->add_template($container,'{COMMENT_TITLE}',$R['COMMENT_TITLE']);
		$reviews->add_template($container,'{COMMENT}',$R['COMMENT']);
	} else {
		$reviews->add_template($container,'{HIDE_COMMENT}',' style="display:none" ');
	}
	$reviews->add_template($container,'{SAVE}',$R['SAVE']);

	if(isset($_SESSION['thereview'])) {
		$reviews->add_template($container,'{NAME_VAL}',@$_SESSION['thereview']['user_name']);
		$reviews->add_template($container,'{EMAIL_VAL}',@$_SESSION['thereview']['user_email']);
		$reviews->add_template($container,'{WEBSITE_VAL}',@$_SESSION['thereview']['user_website']);
		$reviews->add_template($container,'{TITLE_VAL}',@$_SESSION['thereview']['comment_title']);
		$reviews->add_template($container,'{COMMENT_VAL}',@$_SESSION['thereview']['comment']);
	}
	$reviews->clean_template($container); // clean unused tags
	echo $container;

} else { 

	$template = $reviews->review_type['output_template'];
	$container = $reviews->get_template('container',$template);
	if(isset($_SESSION['message'])) {
		$reviews->add_template($container,'{MESSAGE}', $_SESSION['message']);
		unset($_SESSION['message']);
	}
	
	if($reviews->review_count == 0) 	$reviews->add_template($container,'{REVIEW_COUNT}', $R['NO_REVIEWS_FOUND']);
	elseif($reviews->review_count == 1) $reviews->add_template($container,'{REVIEW_COUNT}', $reviews->review_count . ' ' . $R['REVIEW_FOUND']);
	elseif($reviews->review_count > 1) 	$reviews->add_template($container,'{REVIEW_COUNT}', $reviews->review_count . ' ' . $R['REVIEWS_FOUND']);
	
	if($reviews->review_count > 0) {
		$reviews->add_template($container,'{VAL_AVG}', $reviews->review_average);
		$reviews->add_template($container,'{MAX_VAL_DASH}', '/'.$reviews->max_rating);
		$reviews->add_template($container,'{MAX_VAL}', $reviews->max_rating);
		$reviews->add_template($container,'{IMG_AVG}','<img class="review_img" src="'. WB_URL .'/modules/reviews/img/' .round($reviews->review_average) .'-stars.png" alt="'.$reviews->review_average.'" />');
		$reviews->add_template($container,'{FA_AVG}', $reviews->fa_stars($reviews->review_average));
		$reviews->add_template($container,'{TXT_AVG}',$R['AVERAGE'].': '.$reviews->review_average);
	}
	
	$reviews->add_template($container,'{TXT_ADD}', $R['ADD']);
	$reviews->add_template($container,'{TXT_SHOWALL}', $R['SHOWALL']);
	$reviews->add_template($container,'{TXT_SHOWPREV}', $R['SHOWPREV']);
	$reviews->add_template($container,'{TXT_SHOWNEXT}', $R['SHOWNEXT']);
	$reviews->add_template($container,'{MAXPAGE}', $reviews->max_per_page);
	
	if($reviews->review_count <= $reviews->reviews_pageone) $reviews->add_template($container,'{SHOWALL}', ' style="display:none" ');

	if($reviews->page) {
		$reviews->add_template($container,'{SHOWALL}', ' style="display:none" ');	
		if($reviews->page > 1) {
			$reviews->add_template($container,'{PREV}', $reviews->page - 1 );	
		} else {
			$reviews->add_template($container,'{SHOWPREV}', ' style="display:none" ');	
		}		
		if($reviews->page < $reviews->total_pages) {
			$reviews->add_template($container,'{NEXT}', $reviews->page + 1 );	
		} else {
			$reviews->add_template($container,'{SHOWNEXT}', ' style="display:none" ');	
		}
	} else {
		$reviews->add_template($container,'{SHOWNEXT}', ' style="display:none" ');	
		$reviews->add_template($container,'{SHOWPREV}', ' style="display:none" ');	
	}
	
	$tmp_reviews = '';
	$rates = $reviews->get_reviews(); 
	foreach ( $rates as $review ) { 
		$rev = $reviews->get_template('reviews',$template);

		if ($reviews->isAdministrator()) {
			$flagged = $review['approved'] == '0' ? " notap" : "";
			$flagged = $review['user_confirmed'] == '0' ? " notap" : $flagged;
			$flagged = $review['spamflagged'] > '0' ? $flagged." spamflagged" : $flagged;
			$reviews->add_template($rev,'{FLAGGED}',$flagged);
			
			$flags = "<a onclick='return confirm(\"".$R['DELETE_SURE']."\");' class='alert' href='?action=delete&id=". $review['review_guid']."'>".$R['DELETE']."</a>";
			$flags = $review['approved'] == '0' ? $flags." <a class='alert' href='?action=accept&id=". $review['review_guid']."'>".$R['NOTAPPROVED']."</a>" : $flags;
			$flags = $review['approved'] == '1' ? $flags." <a class='alert' href='?action=unaccept&id=". $review['review_guid']."'>".$R['UNAPPROVE']."</a>" : $flags;
			$flags = $review['user_confirmed'] == '0' ? $flags." <a class='alert' href='?action=confirm&id=". $review['user_guid']."'>".$R['NOTCONFIRMED']."</a>" : $flags;
			$flags = $review['spamflagged'] > '0' ? $flags." <a class='alert' href='?action=nospam&id=". $review['review_guid']."'>".$R['SPAMMER']."</a>" : $flags;
			$flags = '<span class="flags">'.$flags.'</span>';
			$reviews->add_template($rev,'{FLAGS}',$flags);			
		}
		
		$reviews->add_template($rev,'{REVIEW_BY}',$reviews->link_fromUrl($review['user_website'], $review['user_name']));
		$reviews->add_template($rev,'{TXT_WROTE}',$R['WROTEON']);
		$reviews->add_template($rev,'{REVIEW_DATE}',date(DATE_FORMAT,$review['timestamp']+TIMEZONE));
		$reviews->add_template($rev,'{REVIEW_TIME}',date(TIME_FORMAT,$review['timestamp']+TIMEZONE));
		$reviews->add_template($rev,'{REVIEW_TITLE}',$review['comment_title']);
		//$reviews->add_template($rev,'{REVIEW_TEXT}',nl2br($review['comment']) );
		$review['comment'] = nl2br($review['comment']);
		if($replies = $reviews->get_replies($review['id'])) {
			foreach($replies as $reply) {

				$review['comment'] .= '<div class="review_reply">';
				if ($reviews->isAdministrator()) $review['comment'] .= "<span class=\"flags\"><a onclick='return confirm(\"".$R['DELETE_SURE']."\");' class='alert' href='?action=delete&id=". $reply['review_guid']."'>".$R['DELETE']."</a></span>";
				$review['comment'] .= '<div class="review_reply_name">'.$reply['user_name'].'<span> '.$R['WROTEON'].' '.date(DATE_FORMAT,$reply['timestamp']+TIMEZONE).' - '.date(TIME_FORMAT,$reply['timestamp']+TIMEZONE).'</span></div>';
				$review['comment'] .= '<div class="review_reply_comment">'.nl2br($reply['comment']).'</div>';
				$review['comment'] .= "</div>";
			}
		}
		if ($reviews->isAdministrator()) {
			$reply = $reviews->get_template('reply',$template);
			$reviews->add_template($reply,'{REPLY}',$R['REPLY']);
			$reviews->add_template($reply,'{SAVE}',$R['SAVE']);
			$reviews->add_template($reply,'{ID}',dechex($review['id']*1234));
			$reviews->add_template($reply,'{NAME}',$R['NAME']);
			$reviews->add_template($reply,'{NAME_VAL}',$_SESSION['DISPLAY_NAME']);
			$review['comment'] .= $reply;
		}

		$reviews->add_template($rev,'{REVIEW_TEXT}',($review['comment']) );
		$reviews->add_template($rev,'{TXT_READFULL}',$R['READ_FULL']);
		$total_count = 0;
		$total_rate = 0;
		for($i=1;$i<=5;$i++) {
			if(!$reviews->review_type['review_q'.$i]) {
				$reviews->add_template($rev,'{SHOW_STAR'.$i.'}',' style="display:none" ');
			} else {
				$total_rate = $total_rate  + $review['review'.$i];
				$total_count += 1;
			}
			$reviews->add_template($rev,'{TXT_STAR'.$i.'}',$reviews->review_type['review_q'.$i]);
			$reviews->add_template($rev,'{VAL_STAR'.$i.'}',$review['review'.$i]);
			$reviews->add_template($rev,'{IMG_STAR'.$i.'}','<img class="review_img" src="'. WB_URL .'/modules/reviews/img/' .$review['review'.$i] .'-stars.png" alt="'.$review['review'.$i].'" title="'.$reviews->review_type['review_q'.$i].': '.$review['review'.$i].'"/>');
			//fontawsome stars
			$reviews->add_template($rev,'{FA_STAR'.$i.'}',$reviews->fa_stars($review['review'.$i]));
		}
		if($total_count > 1) {
			$average = round($total_rate / $total_count);
			$float_average = round($total_rate / $total_count,1);
			$reviews->add_template($rev,'{TXT_AVERAGE}',$R['AVERAGE']);
			$reviews->add_template($rev,'{VAL_AVERAGE}',$float_average);
			$reviews->add_template($rev,'{IMG_AVERAGE}','<img class="review_img" src="'. WB_URL .'/modules/reviews/img/' .$average .'-stars.png" alt="'.$R['AVERAGE'].'" title="'.$R['AVERAGE'].': '.$float_average.'"/>');
			$reviews->add_template($rev,'{FA_AVERAGE}',$reviews->fa_stars($float_average));
		}
		$reviews->add_template($rev,'{TXT_REPLY}',$R['REPLY']);

		$likeid = dechex($review['id']*1234);
		$likes = $review['like'];
		$nolikes = $review['notlike'];
		$reviews->add_template($rev,'{TXT_LIKE_NOLIKE}',$R['LIKE_NOLIKE']);
		$reviews->add_template($rev,'{LIKE}','<span class="likes like" data-id="'.$likeid.'"><i class="star fa fa-thumbs-up" aria-hidden="true"></i><span class="count" id="L'.$likeid.'">'.$likes.'</span></span>');
		$reviews->add_template($rev,'{NOLIKE}','<span class="likes nolike"  data-id="'.$likeid.'"><i class="star fa fa-thumbs-down" aria-hidden="true"></i><span class="count" id="N'.$likeid.'">'.$nolikes.'</span></span>');

		$tmp_reviews .= $rev;
	}
	
	$reviews->add_template($container,'{REVIEWS}', $tmp_reviews);
	$reviews->add_template($container,'{GOOGLE_SNIPPET}', $reviews->google_snippet());
	$reviews->clean_template($container); // clean unused tags
	echo $container;
}  ?>
